	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

.code
Print proc
Local Buffer[MAX_PATH]:CHAR
Local N:ULONG
	mov eax,D[ebp][8]
	lea ecx,[ebp][12]
	invoke vsprintf, addr Buffer, Eax, Ecx
	push eax
	invoke GetStdHandle, STD_OUTPUT_HANDLE
	pop edx
	mov ecx,eax
	invoke WriteFile, Ecx, addr Buffer, Edx, addr N, NULL
	ret
Print endp

EOL		equ NULL
CRLF		equ <13, 10, EOL>

DbgPrint proto C

%DBG macro Msg$, ArgList:VARARG
Local S$
	pushfd
	pushad
	Args = 1
	For Arg, <ArgList>
		Args = Args + 1
		push Arg
	Endm
.data
	S$ CHAR Msg$, CRLF
.code
	push offset S$
	Call Print
	add esp,Args * 4
	popad
	popfd
endm

GTC proc C
	invoke GetTickCount
	ret
GTC endp

TICKS	equ 2000

IPS proc uses ebx esi edi
Local C0, C1, C2, C3, C4:ULONG
Local Des:QWORD
Local S$[16]:CHAR
	invoke AllocConsole
	invoke GTC
	lea esi,[eax][TICKS]
	
	xor edi,edi
	.repeat
		invoke GTC
		inc edi
	.until Eax >= Esi
	mov C0,edi
	
	lea esi,[eax][TICKS]
	xor edi,edi
	.repeat
		xor eax,eax
		cpuid
		invoke GTC
		inc edi
	.until Eax >= Esi
	mov C1,edi
	
	lea esi,[eax][TICKS]
	xor edi,edi
	.repeat
		rdtsc
		invoke GTC
		inc edi
	.until Eax >= Esi
	mov C2,edi

	lea esi,[eax][TICKS]
	xor edi,edi
	.repeat
		smsw eax
		invoke GTC
		inc edi
	.until Eax >= Esi
	mov C3,edi

	lea esi,[eax][TICKS]
	xor edi,edi
	.repeat
		sidt Des
		sgdt Des
		invoke GTC
		inc edi
	.until Eax >= Esi
	mov C4,edi

	lea esi,C1
	mov edi,4
	xor edx,edx
	.repeat
		mov eax,C0
		xor edx,edx
		div D[esi]
		mov D[esi],eax
		sub esi,4
		dec edi
	.until Zero?
	
	%DBG "CPUID %d", C1
	%DBG "RDTSC %d", C2
	%DBG "SMSW  %d", C3
	%DBG "SxDT  %d", C4
	invoke Sleep, INFINITE
	ret
IPS endp
end IPS